var isIE = (navigator.appVersion.indexOf("MSIE") != -1);
var tntCtrlVersion = "1.0.1.8";

function element(id)
{
	return document.getElementById(id);
}

var tntCtrl;
var lastDoInstall;

function doTNTCommand(string)
{
	if (tntCtrl)
	{
		return tntCtrl.doCommand(string);
	}
	return "";
}

function setTNTFocus()
{
	if(tntCtrl)
	{
		tntCtrl.SetFocus();
	}
}

function initTurnTool()
{
	if(TNTsupportedPlatform())
	{
		var doInstall = true;
		if (isTurnToolInstalled()==true)
		{
			if (isTurnToolNewestVersion()==true)
			{
				doInstall = false;
			}
		}
		if (lastDoInstall != doInstall)
		{
			lastDoInstall = doInstall;
			changeTurnToolTag(tntSizeX,tntSizeY,tntSource, tntBackColor, doInstall, '');
		}
		if (doInstall)
		{
			if (!isIE)
			{
				navigator.plugins.refresh();
			}
			setTimeout('initTurnTool()', 1000);
		}
	}
}

function TNTsupportedPlatform()
{
	if (navigator.platform.toString().indexOf("Win") != -1)
	{
		if (navigator.appVersion.indexOf("MSIE") != -1)
		{
			return true;
		}
		if (navigator.userAgent.toLowerCase().indexOf("firefox") != -1)
		{
			return true;
		}
		if (navigator.userAgent.toLowerCase().indexOf("mozilla") != -1)
		{
			return true;
		}
	}
	return false;
}

function isTurnToolInstalled()
{
	var tntInstalled = false;
	if (isIE)
	{
		try
		{
			var xObj = new ActiveXObject("TT2011.TNTCtrl");
			if (xObj)
			{
				tntInstalled = true;
			}
		}
		catch (e)
		{
		}
	}
	else
	{
		var v = navigator.plugins.namedItem("TurnTool2011");
		if(v) 
		{
			tntInstalled = true;
		}
	}
	return tntInstalled;
}

function isTurnToolNewestVersion()
{
	var tntInstalled = false;
	if(isIE)
	{
		try
		{
			var xObj = new ActiveXObject("TT2011.TNTCtrl");
			if (xObj)
			{
				var version = xObj.version.split(".");
				var minversion = tntCtrlVersion.split(".");
				for (var i=0; i<minversion.length; i++)
				{
					if (i >= version.length)
						break;
					if (version[i] > minversion[i])
					{
						tntInstalled = true;
						break;
					}
					if (version[i] < minversion[i])
						break;
					if (i == (minversion.length-1))
						tntInstalled = true;
				}
			}
		}
		catch (e)
		{
		}
	}
	else
	{
		var isSupported = navigator.mimeTypes['application/x-tt2011'];
		isSupported = isSupported && isSupported.enabledPlugin; //in case they disabled it
		if(isSupported)
		{
			var v = navigator.plugins.namedItem("TurnTool2011");
			if(v && v.description)
			{
				var version = v.description.substring(13,v.description.length).split(".");
				var minversion = tntCtrlVersion.split(".");
				for (var i=0; i<minversion.length; i++)
				{
					if (i >= version.length)
						break;
					if (version[i] > minversion[i])
					{
						tntInstalled = true;
						break;
					}
					if (version[i] < minversion[i])
						break;
					if (i == (minversion.length-1))
						tntInstalled = true;
				}
			}
		}	
	}
	return tntInstalled;
}

function changeTurnToolTag(width, height, file, color, doInstall, tntCtrlNumber)
{
	var turntoolObject = '';
	if (doInstall)
	{
		turntoolObject = '<div id="TTInstallTag"><CENTER><a href="http://tt11.turntool.com/TurnTool2011.exe"><img src="'+filesPath+'install_turntool.png" alt="" border="0"></img></a></CENTER></div>';
	}
	else
	{
		if (isIE)
		{
			turntoolObject = ' <object id="TNTCtrl" style="cursor: pointer;" width="'+width+'" height="'+height+'" classid="CLSID:4a8a5cc4-d0f5-4e7b-aaea-bfc70446bfda"';
			turntoolObject += ' codebase="http://tt11.turntool.com/TurnTool2011.exe">';
			if (tntBackColor!='')
			{
				turntoolObject += '<param name="backcolor" value="'+color+'">';
			}
			turntoolObject += '<param name="tnttype" value="viewer">';
			turntoolObject += '<param name="tnt_id" value="TNTCtrl"'+tntCtrlNumber+'>';
			turntoolObject += '<param name="videoDevice" value="'+tntVideoDevice+'">';
			turntoolObject += '<param name="realtimeAntialias" value="'+tntRealtimeAntialias+'">';
			turntoolObject += '<param name="antialiasPasses" value="'+tntAntialiasPasses+'">';
			turntoolObject += '<param name="src" value=""></object>';
			turntoolObject += '<sc'+'r'+'ipt LANGUAGE=JavaScript FOR=TNTCtrl EVENT=TNTEvent(string)> execScript(string); </sc'+'r'+'ipt>';
		}
		else
		{
			turntoolObject = '<embed id="TNTCtrl'+tntCtrlNumber+'" style="cursor: pointer;" width="'+width+'" height="'+height+'" ';
			if (tntBackColor!='')
			{
				turntoolObject += 'backcolor="'+color+'" ';
			}
			turntoolObject += 'tnttype="viewer" videoDevice="'+tntVideoDevice+'" realtimeAntialias="'+tntRealtimeAntialias+'" antialiasPasses="'+tntAntialiasPasses+'" type="application/x-tt2011"></embed>';
		}
	}
	element('TurnTool'+tntCtrlNumber).innerHTML = turntoolObject;
}

function doCommand(commandEditID)
{
	var command = element(commandEditID).value;
	if (command)
	{
		var returnValue = doTNTCommand(command);
		if (returnValue)
		{
			debugOut(command+' || Return Value = "'+returnValue+'"');
		}
		else
		{
			debugOut(command);
		}
	}
}

function debugOut(debugInfo)
{
	if (tntDebug)
	{
		if (tntDebugToConsole)
		{
			if(typeof window.console !== 'undefined')
			{
				console.log("%o", debugInfo);
			}
		}
		if (tntDebugToHTML)
		{
			var debugTag = element('DebugInfo');
			if (debugTag)
			{
				var currDebugInfo = debugTag.innerHTML;
				debugInfo += '<br />';
				debugInfo += currDebugInfo;
				debugTag.innerHTML = debugInfo;
			}
		}
	}
}			

function addEvent(obj, type, fn)
{
	if (obj.addEventListener)
		obj.addEventListener( type, fn, false );
	else if (obj.attachEvent)
	{
		obj["e"+type+fn] = fn;
		obj.attachEvent( "on"+type, function() { obj["e"+type+fn](); } );
	}
}

function removeEvent(obj, type, fn)
{
	if (obj.removeEventListener)
		obj.removeEventListener( type, fn, false );
	else if (obj.detachEvent)
	{
		obj.detachEvent( "on"+type, obj["e"+type+fn] );
		obj["e"+type+fn] = null;
	}
}
