function OnInitialize(tntCtrlID)
{
	tntCtrl = element(tntCtrlID);
	var ttInstallTag = element('TTInstallTag');
	if (ttInstallTag)
	{
		ttInstallTag.innerHTML = '';
	}
	doTNTCommand('Downloader().ShowProgressBar(0)');
	var eventCount = doTNTCommand('EventManager().GetEventCount()');
	for (var eIdx=1; eIdx<eventCount; eIdx++)
	{
		var eventName = doTNTCommand('EventManager().GetEventName('+eIdx+')');
		if (eval("typeof("+eventName+")") == 'function')
		{
			doTNTCommand('EventManager().SetEventEnabled('+eIdx+',1)');
		}
	}
    doTNTCommand('CreateNode("Target1").SetLocalPosition(1000,1000,0)');
    doTNTCommand('CreateCamera("Camera1").SetLocalPosition(5000,5000,5000).SetCameraTarget("Target1").SetCameraMinDistance(0).SetCameraMaxDistance(2000000).SetCameraMoveSpeed(1.5).SetCameraNearClipPlane(1).SetCameraFarClipPlane(-1).SetCameraFOV(90).SetCurrentCamera()');
    doTNTCommand('CreateViewport("Viewport1").SetCurrentViewport().ViewportFrame().SetViewportBackgroundColor(#FFFFFF).SetViewportAmbientColor(#303030).SetViewportMinLight(#000000).SetViewportMaxLight(#ffffff).CreateBackground().LoadBitmap("TestImage.jpg")');
    doTNTCommand('CreateLight("Light1").SetLocalPosition(0,0,0).SetLightRange(1000000).SetLightAttenuation(1.0,0,0).SetLightDiffuseColor(#ffffff).SetLightSpecularColor(#ffffff).SetLightAmbientColor(#000000).SetParent("Camera1")');
    doTNTCommand('CreateMesh("MyMesh1").SetLocalPosition(-150,-150,0).Store("something").CreateMeshFrame().CreateFaceSegment().CreateVertexSegment().AppendPosition(0,0,0).AppendPosition(0,50,0).AppendPosition(0,20,50).AppendNormal(1,0,0).AppendNormal(1,0,0).AppendNormal(1,0,0).AppendFace(0,1,2).AppendFace(2,1,0).SetEnabled(1)');
    AddBox(0,0,0);
	resizePage();
	debugOut('OnInitialize("'+tntCtrlID+'")');
	setTNTFocus();
}

function AddBox(x,y,z)
{
   doTNTCommand('CreateMesh("box'+x+'_'+y+'_'+z+'").SetLocalPosition('+x+','+y+','+z+').GenerateBox(200.0,200.0,200.0)');
   x += 400;
   if (x > 2000)
   {
   	  y += 400.0;
   	  x = 0.0
   }
   if (y>2000.0)
   {
   	 z += 400.0;
   	 y = 0;
   }
   if (z<2000.0)
   {
     setTimeout('AddBox('+x+','+y+','+z+')',0);
   }
}

function OnFileDownloadProgress(fileName,downloadFactor)
{
	debugOut('OnFileDownloadProgress("'+fileName+'",'+downloadFactor+')');
}

function OnFileDownloadComplete(fileName)
{
	debugOut('OnFileDownloadComplete("'+fileName+'")');
}

var mouseOverName = '';

function OnMouseEnter( nodeName, nodeIndex )
{
	mouseOverName = nodeName;
	debugOut('OnMouseEnter("'+nodeName+'", nodeIndex)');
}

function OnMouseExit( nodeName, nodeIndex )
{
	mouseOverName = '';
	debugOut('OnMouseExit("'+nodeName+'", nodeIndex)');
}

function OnKeyPress(keyIndex)
{
	debugOut('OnKeyPress('+keyIndex+')');
	if (keyIndex==27)
	{
		doTNTCommand('Viewport(0).ViewportFrame().Texture().LoadBitmap("blue.bmp")');
	}
	else if (keyIndex==28)
	{
		doTNTCommand('Viewport(0).ViewportFrame().Texture().LoadBitmap("blue.jpg")');
	}
	else if (keyIndex==29)
	{
		doTNTCommand('Viewport(0).ViewportFrame().Texture().LoadBitmap("blue.png")');
	}
	else if (keyIndex==30)
	{
		doTNTCommand('Viewport(0).ViewportFrame().Texture().LoadBitmap("green.bmp")');
	}
	else if (keyIndex==31)
	{
		doTNTCommand('Viewport(0).ViewportFrame().Texture().LoadBitmap("green.jpg")');
	}
	else if (keyIndex==32)
	{
		doTNTCommand('Viewport(0).ViewportFrame().Texture().LoadBitmap("green.png")');
	}
	else if (keyIndex==33)
	{
		doTNTCommand('Viewport(0).ViewportFrame().Texture().LoadBitmap("red.bmp")');
	}
	else if (keyIndex==34)
	{
		doTNTCommand('Viewport(0).ViewportFrame().Texture().LoadBitmap("red.jpg")');
	}
	else if (keyIndex==35)
	{
		doTNTCommand('Viewport(0).ViewportFrame().Texture().LoadBitmap("red.png")');
	}
	else if (keyIndex==67)
	{
		doTNTCommand('Viewport(0).ViewportFrame().Texture().LoadBitmap("TestImage.jpg")');
	}
}

function OnKeyRelease(keyIndex)
{
	debugOut('OnKeyRelease('+keyIndex+')');
}

function OnScriptError(text)
{
	debugOut('OnScriptError('+text+')');	
}

function resizePage()
{
	var iPageWidth = getViewabelSize('x');
	var iPageHeight = getViewabelSize('y');
	var tntCtrl = element('TNTCtrl');
	if (tntCtrl)
	{
		tntCtrl.width = iPageWidth;
		tntCtrl.height = iPageHeight;
		setTNTFocus();
	}
}

function beforeInitialize()
{
	tntSizeX = getViewabelSize('x');
	tntSizeY = getViewabelSize('y');
	if ((tntSizeX>0)&&(tntSizeY>0))
	{
		initTurnTool();
	}
	else
	{
		setTimeout('beforeInitialize()',100);
	}
}

function getViewabelSize(xaxis)
{
	var winWidth = 0;
	var winHeight = 0;
	if( typeof( window.innerWidth ) == 'number' ) {
			//Non-IE
			winWidth = window.innerWidth;
			winHeight = window.innerHeight;
		} else if( document.documentElement && ( document.documentElement.clientWidth || document.documentElement.clientHeight ) ) {
			//IE 6+ in 'standards compliant mode'
			winWidth = document.documentElement.clientWidth;
			winHeight = document.documentElement.clientHeight;
		} else if( document.body && ( document.body.clientWidth || document.body.clientHeight ) ) {
			//IE 4 compatible
			winWidth = document.body.clientWidth;
			winHeight = document.body.clientHeight;
	}
	if(xaxis == true || xaxis.toString().toLowerCase() == 'x')
		return winWidth;
	return winHeight;
}